
/**
 * Created by IntelliJ IDEA.
 * User: naeem
 * Date: Mar 24, 2004
 * Time: 10:08:45 AM
 */

/**
 * This thread is consumer ehich means it reads items from queue that assigned to it
 * this thread stops when its queue goes in except condition
 */
public class Reader extends Thread {
    public Reader(Queue myq) {
            q = myq;
    }

    /**
     * It consumes till queue is in except condition
     */
    public void run() {
        while (!q.isExcept()) {
            synchronized (q) {
                if (q.isExcept())
                    break;

                try {
                    System.out.println("Read: " + q.Dequeue());
                } catch (QueueIsEmptyException e) {
                    q.setExcept();
                    System.out.println("Couldn't Read because queue is empty!!");
                }
            }
        }
    }

    /**
     * Assigned queue
     */
    private Queue q;
}
